// (c)2009 by Texas Instruments Incorporated, All Rights Reserved.
/*----------------------------------------------------------------------------+
|                                                                             |
|                              Texas Instruments                              |
|                                                                             |
|                             USB HID for BSL                                 |
|                                                                             |
+-----------------------------------------------------------------------------+
|  Source: UsbHidReq.h, v1.1 2009/06/29                                       |
|  Author: Rostyslav Stolyar                                                  |
|                                                                             |
|  Release Notes:                                                             |
|  Logs:                                                                      |
|                                                                             |
|  WHO          WHEN         WHAT                                             |
|  ---          ----------   ------------------------------------------------ |
|  R.Stolyar    2009/01/21   born                                             |
|  R.Stolyar    2009/04/20   Change version number to v1.0                    |
|  R.Stolyar    2009/06/24   Change to _tiny version                          |
+----------------------------------------------------------------------------*/

#include "device.h"
#include "types.h"      // Basic Type declarations
#include "usb.h"        // USB-specific Data Structures
#include "descriptors.h"
#include "Proj_Settings.h"


VOID usbClearOEP0ByteCount(VOID);
VOID usbSendDataPacketOnEP0(PBYTE pbBuffer);
VOID usbReceiveDataPacketOnEP0(PBYTE pbBuffer);


VOID usbGetHidDescriptor(VOID)
{
    usbClearOEP0ByteCount();
    wBytesRemainingOnIEP0 = 9;
    usbSendDataPacketOnEP0((PBYTE)&abromConfigurationDescriptorGroup[startHidDescriptor]);
}

//----------------------------------------------------------------------------

VOID usbGetReportDescriptor(VOID)
{
    wBytesRemainingOnIEP0 = SIZEOF_REPORT_DESCRIPTOR;
    usbSendDataPacketOnEP0((PBYTE)&abromReportDescriptor);
}

//----------------------------------------------------------------------------


/*
VOID usbSetReport(VOID)
{
    usbReceiveDataPacketOnEP0((PBYTE) &abUsbRequestIncomingData);     // receive data over EP0 from Host
} 
*/

//----------------------------------------------------------------------------

/*
VOID Handler_InReport(VOID)
{
}

//----------------------------------------------------------------------------

VOID usbGetReport(VOID)
{
    Handler_InReport();
}
*/

//----------------------------------------------------------------------------

/*
VOID Handler_OutReport(VOID)
{
}
*/
