// (c)2009 by Texas Instruments Incorporated, All Rights Reserved.
/*----------------------------------------------------------------------------+
|                                                                             |
|                              Texas Instruments                              |
|                                                                             |
|                             USB HID for BSL                                 |
|                                                                             |
+-----------------------------------------------------------------------------+
|  Source: UsbHidReq.h, v1.1 2009/06/29                                       |
|  Author: Rostyslav Stolyar                                                  |
|                                                                             |
|  Release Notes:                                                             |
|  Logs:                                                                      |
|                                                                             |
|  WHO          WHEN         WHAT                                             |
|  ---          ----------   ------------------------------------------------ |
|  R.Stolyar    2009/01/21   born                                             |
|  R.Stolyar    2009/04/20   Change version number to v1.0                    |
|  R.Stolyar    2009/06/24   Change to _tiny version                          |
+----------------------------------------------------------------------------*/

#ifndef _UsbHidReq_H_
#define _UsbHidReq_H_

#ifdef __cplusplus
extern "C"
{
#endif


/**
\fn      VOID usbGetHidDescriptor(VOID);

\brief   Return Hid descriptor to host over control endpoint
*/
VOID usbGetHidDescriptor(VOID);

/**
\fn      VOID usbGetReportDescriptor(VOID);

\brief   Return HID report descriptor to host over control endpoint
*/
VOID usbGetReportDescriptor(VOID);

/**
\fn      VOID usbSetReport(VOID);

\brief   Receive Out-report from host
*/
VOID usbSetReport(VOID);

/**
\fn      VOID usbGetReport(VOID);

\brief   Return In-report or In-feature-report to host over interrupt endpoint
*/
VOID usbGetReport(VOID);

#ifdef __cplusplus
}
#endif
#endif //_UsbHidReq_H_
