// (c)2009 by Texas Instruments Incorporated, All Rights Reserved.
/*----------------------------------------------------------------------------+
|                                                                             |
|                              Texas Instruments                              |
|                                                                             |
|                          USB HID for BSL                                    |
|                                                                             |
+-----------------------------------------------------------------------------+
|  Source: descripotrs.h, v1.1 2009/06/29                                     |
|  Author: Rostyslav Stolyar                                                  |
|                                                                             |
|  Release Notes:                                                             |
|  Logs:                                                                      |
|                                                                             |
|  WHO          WHEN         WHAT                                             |
|  ---          ----------   ------------------------------------------------ |
|  R.Stolyar    2009/01/21   born                                             |
|  R.Stolyar    2009/04/20   Change version number to v1.0                    |
|  R.Stolyar    2009/06/24   Change to _tiny version                          |
|  L.Westlund   2010/03/15   Removed VID/PID                                  |
+----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------+
| Include files                                                               |
+----------------------------------------------------------------------------*/
#include "Proj_Settings.h"

#define startHidDescriptor 18

#define MAX_PACKET_SIZE   0x40

//#define USB_STR_INDEX_SERNUM 1 // set to 0 if not SerialNumber String descriptor will be used
                               // or set to 1 if the serial number from TLV structure should be used

//Controls whether the remote wakeup feature is supported by this device.
//    A value of 0x20 indicates that is it supported (this value is the mask for
//    the bmAttributes field in the configuration descriptor).
//    A value of zero indicates remote wakeup is not supported.
//    Other values are undefined, as they will interfere with bmAttributes.
#define USB_SUPPORT_REM_WAKE    0 //CFG_DESC_ATTR_REMOTE_WAKE

//Controls whether the application is BUS powered
//    (gets the current for its functionality from USB bus) or SELF powered.
//    Set 0x80 for BUS powered device
//    or set to 0x40 for self powered device
#define USB_SUPPORT_BUS_POWERED CFG_DESC_ATTR_BUS_POWERED

//#define wTotalLength 53     // wTotalLength, CDC
#define wTotalLength 41     // wTotalLength, HID
#define USB_NUM_CONFIGURATIONS  1    // Number of implemented interfaces
//#define bInterfaceNumberCdc     0
#define bInterfaceNumberHid 0


#define SIZEOF_REPORT_DESCRIPTOR 64-28

extern BYTE const abromDeviceDescriptor[SIZEOF_DEVICE_DESCRIPTOR];

extern BYTE const abromConfigurationDescriptorGroup[wTotalLength];

extern BYTE const abromReportDescriptor[];


/*------------------------ Nothing Below This Line --------------------------*/
