/*******************************************************************************
;   Example of an Main Application to be used in conjunction with G2xxx_BSL
;
;                MSP430G2xxx
;             -----------------
;         /|\|                 |
;          | |        P1.0/P1.6|---> LED for MAIN application
;          --|RST              |
;            |                 |
;            |      BSLPIN/P1.3|<--- Enable Pin / S2 on LaunchPad
;            |                 |
;            |                 |
;            |          rX/P1.1|<--- UART 9600 8N1
;            |          tX/P1.2|---> rx/tx swapped on LaunchPad!
;             -----------------
;
;
;   Texas Instruments
;   Built with CCS 4.2.3 and IAR 5.20.1
;
;*******************************************************************************
;
;******************************************************************************/


#include <msp430.h>

//#define LED   BIT0                    // RED LED
#define LED   BIT6                      // GREEN LED

int main(void)
{
  WDTCTL = WDTPW + WDTHOLD;             // Stop watchdog timer
  P1DIR |= LED;                         // Set P1.LED to output direction

  for (;;)
  {
    volatile unsigned int repCnt, delay;// volatile to prevent optimization


    repCnt = 4;                         // Rep Count
    while(repCnt--){
    	P1OUT ^= LED;                   // Toggle P1.LED using exclusive-OR
    	delay = 0x0FFFF;               // Delay to R15
    	while(delay){
    		delay--;
    		delay++;
    		delay--;
    	}
    }

    repCnt = 10;                        // Rep Count
    while(repCnt--){
    	P1OUT ^= LED;                   // Toggle P1.LED using exclusive-OR
    	delay = 0x0AFFF;                // Delay to R15
    	while(delay){
    		delay--;
    		delay++;
    		delay--;
    	}
    }

    repCnt = 20;                        // Rep Count
    while(repCnt--){
    	P1OUT ^= LED;                   // Toggle P1.LED using exclusive-OR
    	delay = 0x057FF;                // Delay to R15
    	while(delay){
    		delay--;
    		delay++;
    		delay--;
    	}
    }

    repCnt = 40;                        // Rep Count
    while(repCnt--){
    	P1OUT ^= LED;                   // Toggle P1.LED using exclusive-OR
    	delay = 0x02BFF;                // Delay to R15
    	while(delay){
    		delay--;
    		delay++;
    		delay--;
    	}
    }
  }
}
