#ifndef __MSP430WARE_FLASH_H__
#define __MSP430WARE_FLASH_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_FLASH__


//*****************************************************************************
//
//The following are values that can be passed to the Flash_status()
//API as the mask parameter.
//
//*****************************************************************************
#define FLASH_READY_FOR_NEXT_WRITE              WAIT_L
#define FLASH_ACCESS_VIOLATION_INTERRUPT_FLAG   ACCVIFG_L
#define FLASH_PASSWORD_WRITTEN_INCORRECTLY      KEYV_L
#define FLASH_BUSY                              BUSY_L

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void Flash_segmentErase (unsigned int baseAddress,
    unsigned char *Flash_ptr);

extern void Flash_bankErase (unsigned int baseAddress, 
                             unsigned char *Flash_ptr);

extern unsigned short Flash_eraseCheck (unsigned int baseAddress,
    unsigned char *Flash_ptr,
    unsigned int numberOfBytes
    );
extern void Flash_write8 (unsigned int baseAddress,
    unsigned char *Data_ptr,
    unsigned char *Flash_ptr,
    unsigned int numberOfBytes
    );
extern void Flash_write16 (unsigned int baseAddress,
    unsigned int *Data_ptr,
    unsigned int *Flash_ptr,
    unsigned int numberOfBytes
    );
extern void Flash_write32 (unsigned int baseAddress,
    unsigned long *Data_ptr,
    unsigned long *Flash_ptr,
    unsigned int numberOfBytes
    );
extern void Flash_memoryFill32 (unsigned int baseAddress,
    unsigned long value,
    unsigned long *Flash_ptr,
    unsigned int count
    );
extern unsigned char Flash_status (unsigned int baseAddress,
    unsigned char mask
    );
#endif
