#ifndef __MSP430WARE_PMM_FR5xx_H__
#define __MSP430WARE_PMM_FR5xx_H__

#define  __MSP430_HAS_PMM_FR5xx__
#define  __MSP430_HAS_PMM_FRAM__


//*****************************************************************************
//
//The following are values that can be passed to the
//PMMInterruptStatus() API as the mask parameter.
//
//*****************************************************************************

#define FRPMM_PMMBORIFG   		PMMBORIFG	/* PMM Software BOR interrupt flag */
#define FRPMM_PMMRSTIFG   		PMMRSTIFG	/* PMM RESET pin interrupt flag */
#define FRPMM_PMMPORIFG   		PMMPORIFG	/* PMM Software POR interrupt flag */
#define FRPMM_SVSHIFG     		SVSHIFG		/* SVS high side interrupt flag */
#define FRPMM_SVSLIFG     		SVSLIFG		/* SVS low side interrupt flag, NOT available for FR58xx/59xx */
#define FRPMM_PMMLPM5IFG  		PMMLPM5IFG  /* LPM5 indication Flag */

#define FRPMM_ALL				(0xB7)

#define FRPMM_LPRST				PMMLPRST	/* Low-Power Reset Enable, ONLY available for FR58xx/59xx */

#define FRPMM_SVSHE				SVSHE
#define FRPMM_SVSLE				SVSLE
#define FRPMM_PMMREGOFF			PMMREGOFF
#define FRPMM_PMMSWPOR			PMMSWPOR
#define FRPMM_PMMSWBOR			PMMSWBOR
#define FRPMM_LOCKLPM5			LOCKLPM5

#define FRPMM_PW                PMMPW
#define FRPMM_PW_H              PMMPW_H

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void FRPMM_enableLowPowerReset 			(unsigned int baseAddress); 	//ONLY available for FR58xx/59xx
extern void FRPMM_disableLowPowerReset 			(unsigned int baseAddress);		//ONLY available for FR58xx/59xx
extern void FRPMM_enableSVSH         			(unsigned int baseAddress);
extern void FRPMM_disableSVSH        			(unsigned int baseAddress);
extern void FRPMM_enableSVSL         			(unsigned int baseAddress);		//ONLY available for FR57xx
extern void FRPMM_disableSVSL        			(unsigned int baseAddress);		//ONLY available for FR57xx
extern void FRPMM_regOff             			(unsigned int baseAddress);
extern void FRPMM_regOn              			(unsigned int baseAddress);
extern void FRPMM_trigPOR            			(unsigned int baseAddress);
extern void FRPMM_trigBOR            			(unsigned int baseAddress);
extern void FRPMM_clearInterrupt       			(unsigned int baseAddress, unsigned int mask);
extern unsigned int FRPMM_getInterruptStatus    (unsigned int baseAddress, unsigned int mask);
extern void FRPMM_lockLPM5           			(unsigned int baseAddress);
extern void FRPMM_unlockLPM5         			(unsigned int baseAddress);

#endif
