#ifndef __MSP430WARE_WDT_H__
#define __MSP430WARE_WDT_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_WDT_A__

//*****************************************************************************
//
//The following are values that can be passed to WDT_watchdogTimerInit() and
//WDT_intervalTimerInit() in the clockSelect parameter.
//
//*****************************************************************************
#define WDT_CLOCKSOURCE_SMCLK  (WDTSSEL_0)
#define WDT_CLOCKSOURCE_ACLK   (WDTSSEL_1)
#define WDT_CLOCKSOURCE_VLOCLK (WDTSSEL_2)
#define WDT_CLOCKSOURCE_XCLK   (WDTSSEL_3)

//*****************************************************************************
//
//The following are values that can be passed to WDT_watchdogTimerInit() and
//WDT_intervalTimerInit in the clockDivider parameter.
//
//*****************************************************************************
#define WDT_CLOCKDIVIDER_2G    (WDTIS_0)
#define WDT_CLOCKDIVIDER_128M  (WDTIS_1)
#define WDT_CLOCKDIVIDER_8192K (WDTIS_2)
#define WDT_CLOCKDIVIDER_512K  (WDTIS_3)
#define WDT_CLOCKDIVIDER_32K   (WDTIS_4)
#define WDT_CLOCKDIVIDER_8192  (WDTIS_5)
#define WDT_CLOCKDIVIDER_512   (WDTIS_6)
#define WDT_CLOCKDIVIDER_64    (WDTIS_7)

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************

extern void WDT_hold (unsigned int baseAddress);

extern void WDT_start (unsigned int baseAddress);

extern void WDT_resetTimer (unsigned int baseAddress);

extern void WDT_watchdogTimerInit (unsigned int baseAddress,
    unsigned char clockSelect,
    unsigned char clockDivider);

extern void WDT_intervalTimerInit (unsigned int baseAddress,
    unsigned char clockSelect,
    unsigned char clockDivider);

#endif
