#ifndef __MSP430WARE_AES_H__
#define __MSP430WARE_AES_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_AES__

//*****************************************************************************
//
//The following value can be passed to AES_clearInterruptFlag(), AES_enableInterrupt(),
// AES_disableInterrupt()
//
//*****************************************************************************
#define AES_READY_INTERRUPT AESRDYIE

//*****************************************************************************
//
//The following value can be returned by AES_getErrorFlagStatus
//
//*****************************************************************************
#define AES_ERROR_OCCURRED	AESERRFG
#define AES_NO_ERROR		0x00

//*****************************************************************************
//
//The following value can be passed to AES_enableInterrupt()
//
//*****************************************************************************
#define		AES_getEncryptedData	AES_getDataOut
#define		AES_getDecryptedData	AES_getDataOut


//*****************************************************************************
//
//The following value is returned by the AES_isBusy() API
//
//*****************************************************************************
#define AES_BUSY		AESBUSY
#define AES_NOT_BUSY	0x00

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
unsigned char AES_setCipherKey (unsigned int baseAddress,
	 const unsigned char * CipherKey
	 );
unsigned char AES_encryptData (unsigned int baseAddress,
	const unsigned char * Data, 
	unsigned char * encryptedData);
unsigned char AES_decryptDataUsingEncryptionKey (unsigned int baseAddress,
	const unsigned char * Data, 
	unsigned char * decryptedData);
unsigned char AES_decryptData (unsigned int baseAddress,
	const unsigned char * Data, 
	unsigned char * decryptedData);
unsigned char AES_generateFirstRoundKey (unsigned int baseAddress,
	const unsigned char * CipherKey);
void AES_clearInterruptFlag (unsigned int baseAddress );
unsigned long AES_getInterruptFlagStatus (unsigned int baseAddress);
void AES_enableInterrupt (unsigned int baseAddress);
void AES_disableInterrupt (unsigned int baseAddress);
void AES_reset (unsigned int baseAddress);
unsigned char AES_startEncryptData (unsigned int baseAddress,
	const unsigned char * Data, 
	unsigned char * encryptedData);
unsigned char AES_startDecryptDataUsingEncryptionKey (
	unsigned int baseAddress, 
	const unsigned char * Data);
unsigned char AES_startDecryptData (unsigned int baseAddress,
	const unsigned char * Data);
unsigned char AES_startGenerateFirstRoundKey (unsigned int baseAddress,
	const unsigned char * CipherKey);
unsigned char  AES_getDataOut(unsigned int baseAddress,
							unsigned char *OutputData
							);
unsigned char AES_isBusy (unsigned int baseAddress);
void AES_clearErrorFlag (unsigned int baseAddress );
unsigned long AES_getErrorFlagStatus (unsigned int baseAddress);
#endif

