#ifndef __MSP430WARE_BAK_BATT_H__
#define __MSP430WARE_BAK_BATT_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_BATTERY_CHARGER__
#define __MSP430_HAS_BACKUP_RAM__

//*****************************************************************************
//
//The following are values that can be returned by BAK_BATT_unlockBackupSubSystem().
//
//*****************************************************************************
#define BAK_BATT_UNLOCKFAILURE (0x0)
#define BAK_BATT_UNLOCKSUCCESS (0x1)

//*****************************************************************************
//
//The following are values that can be passed to BAK_BATT_chargerInitAndEnable()
//in the chargerEndVoltage parameter.
//
//*****************************************************************************
#define BAK_BATT_CHARGERENDVOLTAGE_VCC (BAKCHV0)
#define BAK_BATT_CHARGERENDVOLTAGE2_7V (BAKCHV1)

//*****************************************************************************
//
//The following are values that can be passed to BAK_BATT_chargerInitAndEnable()
//in the chargeCurrent parameter.
//
//*****************************************************************************
#define BAK_BATT_CHARGECURRENT_5KOHM  (BAKCHC0)
#define BAK_BATT_CHARGECURRENT_10KOHM (BAKCHC1)
#define BAK_BATT_CHARGECURRENT_20KOHM (BAKCHC0 + BAKCHC1)

//*****************************************************************************
//
//The following are values that can be passed to BAK_BATT_setBackupRAMData() and
//BAK_BATT_getBackupRAMData() in the backupRAMSelect parameter.
//
//*****************************************************************************
#define BAK_BATT_RAMSELECT_0 (0x0000)
#define BAK_BATT_RAMSELECT_1 (0x0002)
#define BAK_BATT_RAMSELECT_2 (0x0004)
#define BAK_BATT_RAMSELECT_3 (0x0006)

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************

extern unsigned short BAK_BATT_unlockBackupSubSystem (unsigned int baseAddress);

extern void BAK_BATT_enableBackupSupplyToADC (unsigned int baseAddress);

extern void BAK_BATT_disableBackupSupplyToADC (unsigned int baseAddress);

extern void BAK_BATT_manuallySwitchToBackupSupply (unsigned int baseAddress);

extern void BAK_BATT_disable (unsigned int baseAddress);

extern void BAK_BATT_chargerInitAndEnable (unsigned int baseAddress,
    unsigned char chargerEndVoltage,
    unsigned char chargeCurrent);

extern void BAK_BATT_disableCharger (unsigned int baseAddress);

extern void BAK_BATT_setBackupRAMData (unsigned int baseAddress,
    unsigned char backupRAMSelect,
    unsigned int data);

extern unsigned int BAK_BATT_getBackupRAMData (unsigned int baseAddress,
    unsigned char backupRAMSelect);


#endif
