#ifndef __MSP430WARE_COMP_B_H__
#define __MSP430WARE_COMP_B_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_COMPB__

//*****************************************************************************
//
//The following are values that can be passed to Comp_init(),
//Comp_disableInputBuffer(), and Comp_enableInputBuffer() in the
//positiveTerminalInput, negativeTerminalInput, and inputPort parameters.
//
//*****************************************************************************
#define COMP_B_INPUT0  (CBIPSEL_0)
#define COMP_B_INPUT1  (CBIPSEL_1)
#define COMP_B_INPUT2  (CBIPSEL_2)
#define COMP_B_INPUT3  (CBIPSEL_3)
#define COMP_B_INPUT4  (CBIPSEL_4)
#define COMP_B_INPUT5  (CBIPSEL_5)
#define COMP_B_INPUT6  (CBIPSEL_6)
#define COMP_B_INPUT7  (CBIPSEL_7)
#define COMP_B_INPUT8  (CBIPSEL_8)
#define COMP_B_INPUT9  (CBIPSEL_9)
#define COMP_B_INPUT10 (CBIPSEL_10)
#define COMP_B_INPUT11 (CBIPSEL_11)
#define COMP_B_INPUT12 (CBIPSEL_12)
#define COMP_B_INPUT13 (CBIPSEL_13)
#define COMP_B_INPUT14 (CBIPSEL_14)
#define COMP_B_INPUT15 (CBIPSEL_15)
#define COMP_B_VREF    (0x10)

//*****************************************************************************
//
//The following are values that can be passed to Comp_init() in the
//powerModeSelect parameter.
//
//*****************************************************************************
#define COMP_B_POWERMODE_HIGHSPEED     (CBPWRMD_0)
#define COMP_B_POWERMODE_NORMALMODE    (CBPWRMD_1)
#define COMP_B_POWERMODE_ULTRALOWPOWER (CBPWRMD_2)

//*****************************************************************************
//
//The following are values that can be passed to Comp_init() in the
//outputFilterEnableAndDelayLevel parameter.
//
//*****************************************************************************
#define COMP_B_FILTEROUTPUT_OFF     0x00
#define COMP_B_FILTEROUTPUT_DLYLVL1 (CBF + CBFDLY_0)
#define COMP_B_FILTEROUTPUT_DLYLVL2 (CBF + CBFDLY_1)
#define COMP_B_FILTEROUTPUT_DLYLVL3 (CBF + CBFDLY_2)
#define COMP_B_FILTEROUTPUT_DLYLVL4 (CBF + CBFDLY_3)

//*****************************************************************************
//
//The following are values that can be passed to Comp_init() in the
//invertedOutputPolarity parameter.
//
//*****************************************************************************
#define COMP_B_NORMALOUTPUTPOLARITY   ( !(CBOUTPOL) )
#define COMP_B_INVERTEDOUTPUTPOLARITY (CBOUTPOL)

//*****************************************************************************
//
//The following are values that can be passed to Comp_setReferenceVoltage() in
//the supplyVoltageBase parameter.
//
//*****************************************************************************
#define COMP_B_VREFBASE_VCC (CBREFL_0)
#define COMP_B_VREFBASE1_5V (CBREFL_1)
#define COMP_B_VREFBASE2_0V (CBREFL_2)
#define COMP_B_VREFBASE2_5V (CBREFL_3)

//*****************************************************************************
//
//The following are values that can be passed to Comp_setReferenceVoltage() in
//the refrenceAccuracy parameter.
//
//*****************************************************************************
#define COMP_B_ACCURACY_STATIC	(!CBREFACC)
#define COMP_B_ACCURACY_CLOCKED	(CBREFACC)

//*****************************************************************************
//
//The following are values that can be passed to Comp_setEdgeDirection() in
//the edgeDirection parameter.
//
//*****************************************************************************
#define COMP_B_FALLINGEDGE ( !(CBIES) )
#define COMP_B_RISINGEDGE  (CBIES)

//*****************************************************************************
//
//The following are values that returned by COMP_B_outputValue().
//
//*****************************************************************************
#define COMP_B_LOW  (0x0)
#define COMP_B_HIGH (0x1)


//*****************************************************************************
//API
//*****************************************************************************

extern unsigned short COMP_B_init (unsigned int baseAddress,
    unsigned char positiveTerminalInput,
    unsigned char negativeTerminalInput,
    unsigned int powerModeSelect,
    unsigned char outputFilterEnableAndDelayLevel,
    unsigned short invertedOutputPolarity);

void COMP_B_setReferenceVoltage (unsigned int baseAddress,
    	unsigned int supplyVoltageReferenceBase,
    	unsigned int lowerLimitSupplyVoltageFractionOf32,
    	unsigned int upperLimitSupplyVoltageFractionOf32,
    	unsigned int refrenceAccuracy);

extern void COMP_B_enableInterrupt (unsigned int baseAddress, unsigned int mask);

extern void COMP_B_disableInterrupt (unsigned int baseAddress,
    unsigned int mask);

extern void COMP_B_clearInterrupt (unsigned int baseAddress, unsigned int mask);

extern unsigned char COMP_B_getInterruptStatus (unsigned int baseAddress,
    unsigned int mask);

extern void COMP_B_interruptSetEdgeDirection (unsigned int baseAddress,
    unsigned short edgeDirection);

extern void COMP_B_interruptToggleEdgeDirection (unsigned int baseAddress);

extern void COMP_B_enable (unsigned int baseAddress);

extern void COMP_B_disable (unsigned int baseAddress);

extern void COMP_B_enableShortOfInputs (unsigned int baseAddress);

extern void COMP_B_disableShortOfInputs (unsigned int baseAddress);

extern void COMP_B_disableInputBuffer (unsigned int baseAddress,
    unsigned char inputPort);

extern void COMP_B_enableInputBuffer (unsigned int baseAddress,
    unsigned char inputPort);

extern void COMP_B_IOSwap (unsigned int baseAddress);

extern unsigned short COMP_B_outputValue (unsigned int baseAddress);

#endif
