#ifndef __MSP430WARE_EUARTBAUDRATE_H__
#define __MSP430WARE_EUARTBAUDRATE_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_EUSCI_Ax__

//*****************************************************************************
//
//The following value selects low frequency mode eand NOT the oversampling mode
//
//*****************************************************************************
#define eUARTBAUDRATE_LOW_FREQUENCY_BAUDRATE_GENERATION    0x00


typedef struct ERROR_STRUCTURE {
    double max_error;
    double max_positive_error;
    double max_negative_error;
}MAX_ERR;


extern double eUARTBAUDRATE_txTbit (unsigned int mode,
    unsigned int i,
    unsigned int s_mod,
    unsigned int f_mod
    );

extern MAX_ERR eUARTBAUDRATE_txError (unsigned int mode,
    unsigned int s_mod,
    unsigned int f_mod
    );

extern MAX_ERR eUARTBAUDRATE_rxError (unsigned int mode,
    unsigned int s_mod,
    unsigned int f_mod,
    double t_sync
    );

extern unsigned short eUARTBAUDRATE_calculateBaudDividers (
    double brclk_f,
    double baudrate_f,
    unsigned int *UCAxBRW_value,
    unsigned int *UCAxMCTL_value,
    unsigned short overSampling
    );
#endif
