#ifndef __MSP430WARE_FLASH_H__
#define __MSP430WARE_FLASH_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_FLASH__


//*****************************************************************************
//
//The following are values that can be passed to the FLASH_status()
//API as the mask parameter.
//
//*****************************************************************************
#define FLASH_READY_FOR_NEXT_WRITE              WAIT_L
#define FLASH_ACCESS_VIOLATION_INTERRUPT_FLAG   ACCVIFG_L
#define FLASH_PASSWORD_WRITTEN_INCORRECTLY      KEYV_L
#define FLASH_BUSY                              BUSY_L

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void FLASH_segmentErase (unsigned int baseAddress,
    unsigned char *flash_ptr);

extern void FLASH_bankErase (unsigned int baseAddress, 
                             unsigned char *flash_ptr);

extern unsigned short FLASH_eraseCheck (unsigned int baseAddress,
    unsigned char *flash_ptr,
    unsigned int numberOfBytes
    );
extern void FLASH_write8 (unsigned int baseAddress,
    unsigned char *Data_ptr,
    unsigned char *flash_ptr,
    unsigned int numberOfBytes
    );
extern void FLASH_write16 (unsigned int baseAddress,
    unsigned int *Data_ptr,
    unsigned int *flash_ptr,
    unsigned int numberOfBytes
    );
extern void FLASH_write32 (unsigned int baseAddress,
    unsigned long *Data_ptr,
    unsigned long *flash_ptr,
    unsigned int numberOfBytes
    );
extern void FLASH_memoryFill32 (unsigned int baseAddress,
    unsigned long value,
    unsigned long *flash_ptr,
    unsigned int count
    );
extern unsigned char FLASH_status (unsigned int baseAddress,
    unsigned char mask
    );
#endif
