#ifndef __MSP430WARE_REF_H__
#define __MSP430WARE_REF_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_REF__

//*****************************************************************************
//
//The following are values that can be passed to REF_setReferenceVoltage()
//in the referenceVoltageSelect parameter.
//
//*****************************************************************************
#define REF_VREF1_5V (REFVSEL_0)
#define REF_VREF2_0V (REFVSEL_1)
#define REF_VREF2_5V (REFVSEL_2)

//*****************************************************************************
//
//The following are values that can be passed to REF_setReferenceVoltage()
//in the referenceVoltageSelect parameter.
//
//*****************************************************************************
#define REF_NOTBUSY (0x0)
#define REF_BUSY    (0x1)

//*****************************************************************************
//
//The following are values that are returned by REF_isBandgapActive()
//and REF_isRefGenActive().
//
//*****************************************************************************
#define REF_INACTIVE (0x0)
#define REF_ACTIVE   (0x1)

//*****************************************************************************
//
//The following are values that are returned by REF_bandgapMode().
//
//*****************************************************************************
#define REF_STATICMODE (0x0)
#define REF_SAMPLEMODE (0x1)

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void REF_setReferenceVoltage (unsigned int baseAddress,
    unsigned char referenceVoltageSelect);

extern void REF_disableTempSensor (unsigned int baseAddress);

extern void REF_enableTempSensor (unsigned int baseAddress);

extern void REF_enableReferenceVoltage (unsigned int baseAddress);

extern void REF_disableReferenceVoltage (unsigned int baseAddress);

extern unsigned short REF_getBandgapMode (unsigned int baseAddress);

extern unsigned short  REF_isBandgapActive (unsigned int baseAddress);

extern unsigned short REF_isRefGenBusy (unsigned int baseAddress);

extern unsigned short REF_isRefGen (unsigned int baseAddress);

#endif
