#ifndef __MSP430WARE_PMM_FRAM_H__
#define __MSP430WARE_PMM_FRAM_H__

#define  __MSP430_HAS_PMM_FRAM__

//*****************************************************************************
//
//The following are values that can be passed to the
//PMM_getInterruptStatus() API as the mask parameter.
//
//*****************************************************************************

#define PMM_PMMBORIFG   		PMMBORIFG	/* PMM Software BOR interrupt flag */
#define PMM_PMMRSTIFG   		PMMRSTIFG	/* PMM RESET pin interrupt flag */
#define PMM_PMMPORIFG   		PMMPORIFG	/* PMM Software POR interrupt flag */
#define PMM_SVSHIFG     		SVSHIFG		/* SVS high side interrupt flag */
#define PMM_SVSLIFG     		SVSLIFG		/* SVS low side interrupt flag, NOT available for FR58xx/59xx */
#define PMM_PMMLPM5IFG  		PMMLPM5IFG  /* LPM5 indication Flag */

#define PMM_ALL				(0xB7)

#define PMM_LPRST				PMMLPRST	/* Low-Power Reset Enable, ONLY available for FR58xx/59xx */

#define PMM_SVSHE				SVSHE
#define PMM_SVSLE				SVSLE
#define PMM_PMMREGOFF			PMMREGOFF
#define PMM_PMMSWPOR			PMMSWPOR
#define PMM_PMMSWBOR			PMMSWBOR
#define PMM_LOCKLPM5			LOCKLPM5

#define PMM_PW                PMMPW
#define PMM_PW_H              PMMPW_H

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void PMM_enableLowPowerReset 			(unsigned int baseAddress); 	
extern void PMM_disableLowPowerReset 			(unsigned int baseAddress);		
extern void PMM_enableSVSH         			(unsigned int baseAddress);
extern void PMM_disableSVSH        			(unsigned int baseAddress);
extern void PMM_regOff             			(unsigned int baseAddress);
extern void PMM_regOn              			(unsigned int baseAddress);
extern void PMM_trigPOR            			(unsigned int baseAddress);
extern void PMM_trigBOR            			(unsigned int baseAddress);
extern void PMM_clearInterrupt       			(unsigned int baseAddress, unsigned int mask);
extern unsigned int PMM_getInterruptStatus    (unsigned int baseAddress, unsigned int mask);
extern void PMM_lockLPM5           			(unsigned int baseAddress);
extern void PMM_unlockLPM5         			(unsigned int baseAddress);

#endif
