#ifndef __MSP430WARE_REF_A_H__
#define __MSP430WARE_REF_A_H__

//*****************************************************************************
//
//The following are the defines to include the required modules for this
//peripheral in msp430xgeneric.h file
//
//*****************************************************************************
#define __MSP430_HAS_REF_A__

//*****************************************************************************
//
//The following are values that can be passed to REF_setReferenceVoltage()
//in the referenceVoltageSelect parameter.
//
//*****************************************************************************
#define REF_A_VREF1_2V (REFVSEL_0)
#define REF_A_VREF2_0V (REFVSEL_1)
#define REF_A_VREF2_5V (REFVSEL_2)

//*****************************************************************************
//
//The following are values that can be passed to REF_setReferenceVoltage()
//in the referenceVoltageSelect parameter.
//
//*****************************************************************************
#define REF_A_NOTBUSY (0x0)
#define REF_A_BUSY    (0x1)

//*****************************************************************************
//
//The following are values that are returned by REF_isBandgapActive()
//and REF_isRefGenActive().
//
//*****************************************************************************
#define REF_A_INACTIVE (0x0)
#define REF_A_ACTIVE   (0x1)

//*****************************************************************************
//
//The following are values that are returned by REF_A_getBufBandVoltStatus()
//and REF_A_getVarRefVoltStatus().
//
//*****************************************************************************
#define REF_A_NOTREADY (0x0)
#define REF_A_READY   (0x1)

//*****************************************************************************
//
//The following are values that are returned by REF_bandgapMode().
//
//*****************************************************************************
#define REF_A_STATICMODE (0x0)
#define REF_A_SAMPLEMODE (0x1)

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void REF_A_setReferenceVoltage (unsigned int baseAddress,
    unsigned char referenceVoltageSelect);

extern void REF_A_disableTempSensor (unsigned int baseAddress);

extern void REF_A_enableTempSensor (unsigned int baseAddress);

extern void REF_A_enableReferenceVoltageOutput (unsigned int baseAddress);

extern void REF_A_disableReferenceVoltageOutput (unsigned int baseAddress);

extern void REF_A_enableReferenceVoltage (unsigned int baseAddress);

extern void REF_A_disableReferenceVoltage (unsigned int baseAddress);

extern unsigned short REF_A_getBandgapMode (unsigned int baseAddress);

extern unsigned short  REF_A_isBandgapActive (unsigned int baseAddress);

extern unsigned short REF_A_isRefGenBusy (unsigned int baseAddress);

extern unsigned short REF_A_isRefGenActive (unsigned int baseAddress);

extern unsigned short REF_A_getBufferedBandgapVoltageStatus(unsigned int baseAddress);

extern unsigned short REF_A_getVariableReferenceVoltageStatus(unsigned int baseAddress);

extern void REF_A_setReferenceVoltageOneTimeTrigger(unsigned int baseAddress);

extern void REF_A_setBufBandgapVoltageOneTimeTrigger(unsigned int baseAddress);


#endif
