#ifndef __MSP430WARE_TIMER_A_H__
#define __MSP430WARE_TIMER_A_H__

#define __MSP430_HAS_TxA7__
//*****************************************************************************
//
//The following are values that can be passed to the
//TIMER_A_startContinuousMode();, TIMER_A_startUpMode();, TIMER_A_startUpDownMode();,
//TIMER_A_generatePWM(); APIs as the clockSource parameter.
//
//*****************************************************************************
#define TIMER_A_CLOCKSOURCE_EXTERNAL_TXCLK            TASSEL__TACLK
#define TIMER_A_CLOCKSOURCE_ACLK                      TASSEL__ACLK
#define TIMER_A_CLOCKSOURCE_SMCLK                     TASSEL__SMCLK
#define TIMER_A_CLOCKSOURCE_INVERTED_EXTERNAL_TXCLK   TASSEL__INCLK

//*****************************************************************************
//
//The following are values that can be passed to the
//TIMER_A_startContinuousMode();, TIMER_A_startUpMode();, TIMER_A_startUpDownMode();,
//TIMER_A_generatePWM(); APIs as the clockSourceDivider parameter.
//
//*****************************************************************************
#define TIMER_A_CLOCKSOURCE_DIVIDER_1     0x01
#define TIMER_A_CLOCKSOURCE_DIVIDER_2     0x02
#define TIMER_A_CLOCKSOURCE_DIVIDER_4     0x04
#define TIMER_A_CLOCKSOURCE_DIVIDER_8     0x08
#define TIMER_A_CLOCKSOURCE_DIVIDER_3     0x03
#define TIMER_A_CLOCKSOURCE_DIVIDER_5     0x05
#define TIMER_A_CLOCKSOURCE_DIVIDER_6     0x06
#define TIMER_A_CLOCKSOURCE_DIVIDER_7     0x07
#define TIMER_A_CLOCKSOURCE_DIVIDER_10    0x0A
#define TIMER_A_CLOCKSOURCE_DIVIDER_12    0x0C
#define TIMER_A_CLOCKSOURCE_DIVIDER_14    0x0E
#define TIMER_A_CLOCKSOURCE_DIVIDER_16    0x10
#define TIMER_A_CLOCKSOURCE_DIVIDER_20    0x14
#define TIMER_A_CLOCKSOURCE_DIVIDER_24    0x18
#define TIMER_A_CLOCKSOURCE_DIVIDER_28    0x1C
#define TIMER_A_CLOCKSOURCE_DIVIDER_32    0x20
#define TIMER_A_CLOCKSOURCE_DIVIDER_40    0x28
#define TIMER_A_CLOCKSOURCE_DIVIDER_48    0x30
#define TIMER_A_CLOCKSOURCE_DIVIDER_56    0x38
#define TIMER_A_CLOCKSOURCE_DIVIDER_64    0x40

//*****************************************************************************
//
//The following are values that can be passed to TIMER_A_startContinuousMode();
//TIMER_A_startUpMode();,  TIMER_A_startUpDownMode(); as the timerClear parameter.
//
//*****************************************************************************
#define TIMER_A_DO_CLEAR      TACLR
#define TIMER_A_SKIP_CLEAR    0x00

//*****************************************************************************
//
//The following are values that can be passed to the
//TIMER_A_getSynchronizedCaptureCompareInput(); API as the synchronized
//parameter.
//
//*****************************************************************************
#define TIMER_A_CAPTURECOMPARE_INPUT                  SCCI
#define TIMER_A_SYNCHRONIZED_CAPTURECOMPARE_INPUT     CCI

//*****************************************************************************
//
//The following are values that is returned by the
//TIMER_A_getSynchronizedCaptureCompareInput(); API
//
//*****************************************************************************
#define TIMER_A_CAPTURECOMPARE_INPUT_HIGH    0x01
#define TIMER_A_CAPTURECOMPARE_INPUT_LOW     0x00


//*****************************************************************************
//
//The following are values that is returned by the
//TIMER_A_getOutputForOutputModeOutBitValue(); and passed to
//TIMER_A_setOutputForOutputModeOutBitValue(); as
//outputModeOutBitValue parameter
//
//*****************************************************************************
#define TIMER_A_OUTPUTMODE_OUTBITVALUE_HIGH    OUT
#define TIMER_A_OUTPUTMODE_OUTBITVALUE_LOW     0x00

//*****************************************************************************
//
//The following are values can be passed to the mask parameter of
//TIMER_A_captureCompareInterruptStatus(); API
//
//*****************************************************************************
#define TIMER_A_CAPTURE_OVERFLOW                  COV
#define TIMER_A_CAPTURECOMPARE_INTERRUPT_FLAG     CCIFG

//*****************************************************************************
//
//The following are values can be passed to the timerInterruptEnable_TAIE
//parameter of TIMER_A_startContinuousMode();, TIMER_A_startUpMode();,
//TIMER_A_startUpDownMode();
//
//*****************************************************************************
#define TIMER_A_TAIE_INTERRUPT_ENABLE            TAIE
#define TIMER_A_TAIE_INTERRUPT_DISABLE           0x00

//*****************************************************************************
//
//The following are values can be passed to the
//captureCompareInterruptEnable_CCR0_CCIE parameter of TIMER_A_startUpMode();,
//TIMER_A_startUpDownMode API
//
//*****************************************************************************
#define TIMER_A_CCIE_CCR0_INTERRUPT_ENABLE   CCIE
#define TIMER_A_CCIE_CCR0_INTERRUPT_DISABLE  0x00

//*****************************************************************************
//
//The following are timer modes possible.
//
//*****************************************************************************
#define TIMER_A_STOP_MODE         MC_0
#define TIMER_A_UP_MODE           MC_1
#define TIMER_A_CONTINUOUS_MODE   MC_2
#define TIMER_A_UPDOWN_MODE       MC_3

//*****************************************************************************
//
//The following are values can be passed to the
//compareRegister, captureCompareRegister or captureRegister parameter
//of TIMER_A_initCapture();, TIMER_A_enableCaptureCompareInterrupt();,
//TIMER_A_disableCaptureCompareInterrupt();,TIMER_A_captureCompareInterruptStatus();,
//TIMER_A_getSynchronizedCaptureCompareInput();,TIMER_A_initCompare();
//
//*****************************************************************************
#define TIMER_A_CAPTURECOMPARE_REGISTER_0     0x02
#define TIMER_A_CAPTURECOMPARE_REGISTER_1     0x04
#define TIMER_A_CAPTURECOMPARE_REGISTER_2     0x06
#define TIMER_A_CAPTURECOMPARE_REGISTER_3     0x08
#define TIMER_A_CAPTURECOMPARE_REGISTER_4     0x0A
#define TIMER_A_CAPTURECOMPARE_REGISTER_5     0x0C
#define TIMER_A_CAPTURECOMPARE_REGISTER_6     0x0E

//*****************************************************************************
//
//The following are values can be passed to the
//captureMode parameter of TIMER_A_initCompare();, TIMER_A_initCapture();,
//TIMER_A_generatePWM();,
//
//*****************************************************************************
#define TIMER_A_OUTPUTMODE_OUTBITVALUE        OUTMOD_0
#define TIMER_A_OUTPUTMODE_SET                OUTMOD_1
#define TIMER_A_OUTPUTMODE_TOGGLE_RESET       OUTMOD_2
#define TIMER_A_OUTPUTMODE_SET_RESET          OUTMOD_3
#define TIMER_A_OUTPUTMODE_TOGGLE             OUTMOD_4
#define TIMER_A_OUTPUTMODE_RESET              OUTMOD_5
#define TIMER_A_OUTPUTMODE_TOGGLE_SET         OUTMOD_6
#define TIMER_A_OUTPUTMODE_RESET_SET          OUTMOD_7

//*****************************************************************************
//
//The following are values can be passed to the
//captureMode parameter of TIMER_A_initCapture(); API
//
//*****************************************************************************
#define TIMER_A_CAPTUREMODE_NO_CAPTURE                CM_0
#define TIMER_A_CAPTUREMODE_RISING_EDGE               CM_1
#define TIMER_A_CAPTUREMODE_FALLING_EDGE              CM_2
#define TIMER_A_CAPTUREMODE_RISING_AND_FALLING_EDGE   CM_3

//*****************************************************************************
//
//The following are values can be passed to the
//synchronizeCaptureSource parameter of TIMER_A_initCapture(); API
//
//*****************************************************************************
#define TIMER_A_CAPTURE_ASYNCHRONOUS                  0x00
#define TIMER_A_CAPTURE_SYNCHRONOUS                   SCS

//*****************************************************************************
//
//The following are values can be passed to the
//captureInterruptEnable, compareInterruptEnable parameter of
//TIMER_A_initCapture(); API
//
//*****************************************************************************
#define TIMER_A_CAPTURECOMPARE_INTERRUPT_ENABLE       CCIE
#define TIMER_A_CAPTURECOMPARE_INTERRUPT_DISABLE      0x00

//*****************************************************************************
//
//The following are values can be passed to the
//captureInputSelect parameter of TIMER_A_initCapture(); API
//
//*****************************************************************************
#define TIMER_A_CAPTURE_INPUTSELECT_CCIxA             CCIS_0
#define TIMER_A_CAPTURE_INPUTSELECT_CCIxB             CCIS_1
#define TIMER_A_CAPTURE_INPUTSELECT_GND               CCIS_2
#define TIMER_A_CAPTURE_INPUTSELECT_Vcc               CCIS_3

//*****************************************************************************
//
//The following are values that may be returned by
//TIMER_A_getInterruptStatus(); API
//
//*****************************************************************************
#define TIMER_A_INTERRUPT_NOT_PENDING     0x00
#define TIMER_A_INTERRUPT_PENDING         0x01

//*****************************************************************************
//
//The following are values can be passed to the
//synchronized parameter of TIMER_A_getSynchronizedCaptureCompareInput(); API
//
//*****************************************************************************
#define TIMER_A_READ_SYNCHRONIZED_CAPTURECOMPAREINPUT SCCI
#define TIMER_A_READ_CAPTURE_COMPARE_INPUT            CCI

//*****************************************************************************
//
//Prototypes for the APIs.
//
//*****************************************************************************
extern void TIMER_A_startCounter ( unsigned int baseAddress,
    unsigned int timerMode
    );
extern void TIMER_A_configureContinuousMode ( unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int timerClear
    );
extern void TIMER_A_configureUpMode (   unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerPeriod,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int captureCompareInterruptEnable_CCR0_CCIE,
    unsigned int timerClear
    );
extern void TIMER_A_configureUpDownMode (
    unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerPeriod,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int captureCompareInterruptEnable_CCR0_CCIE,
    unsigned int timerClear
    );
extern void TIMER_A_startContinuousMode ( unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int timerClear
    );
extern void TIMER_A_startContinousMode ( unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int timerClear
    );
extern void TIMER_A_startUpMode (   unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerPeriod,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int captureCompareInterruptEnable_CCR0_CCIE,
    unsigned int timerClear
    );
extern void TIMER_A_startUpDownMode (
    unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerPeriod,
    unsigned int timerInterruptEnable_TAIE,
    unsigned int captureCompareInterruptEnable_CCR0_CCIE,
    unsigned int timerClear
    );
extern void TIMER_A_initCapture (unsigned int baseAddress,
    unsigned int captureRegister,
    unsigned int captureMode,
    unsigned int captureInputSelect,
    unsigned short synchronizeCaptureSource,
    unsigned short captureInterruptEnable,
    unsigned int captureOutputMode
    );
extern void TIMER_A_initCompare (  unsigned int baseAddress,
    unsigned int compareRegister,
    unsigned short compareInterruptEnable,
    unsigned int compareOutputMode,
    unsigned int compareValue
    );
extern void TIMER_A_enableInterrupt (unsigned int baseAddress);
extern void TIMER_A_disableInterrupt (unsigned int baseAddress);
extern unsigned long TIMER_A_getInterruptStatus (unsigned int baseAddress);
extern void TIMER_A_enableCaptureCompareInterrupt (unsigned int baseAddress,
    unsigned int captureCompareRegister
    );
extern void TIMER_A_disableCaptureCompareInterrupt (unsigned int baseAddress,
    unsigned int captureCompareRegister
    );
extern unsigned long TIMER_A_getCaptureCompareInterruptStatus (unsigned int baseAddress,
		 unsigned int captureCompareRegister,
		 unsigned int mask
		 );
extern void TIMER_A_clear (unsigned int baseAddress);
extern unsigned short TIMER_A_getSynchronizedCaptureCompareInput
    (unsigned int baseAddress,
    unsigned int captureCompareRegister,
    unsigned short synchronized
    );
extern unsigned char TIMER_A_getOutputForOutputModeOutBitValue
    (unsigned int baseAddress,
    unsigned int captureCompareRegister
    );
extern unsigned int TIMER_A_getCaptureCompareCount
    (unsigned int baseAddress,
    unsigned int captureCompareRegister
    );
extern void TIMER_A_setOutputForOutputModeOutBitValue
    (unsigned int baseAddress,
    unsigned int captureCompareRegister,
    unsigned char outputModeOutBitValue
    );
extern void TIMER_A_generatePWM (  unsigned int baseAddress,
    unsigned int clockSource,
    unsigned int clockSourceDivider,
    unsigned int timerPeriod,
    unsigned int compareRegister,
    unsigned int compareOutputMode,
    unsigned int dutyCycle
    );
extern void TIMER_A_stop ( unsigned int baseAddress );
extern void TIMER_A_setCompareValue (  unsigned int baseAddress,
    unsigned int compareRegister,
    unsigned int compareValue
    );
extern void TIMER_A_clearTimerInterruptFlag (unsigned int baseAddress);
extern void TIMER_A_clearCaptureCompareInterruptFlag (unsigned int baseAddress,
    unsigned int captureCompareRegister
    );
#endif
