/*******************************************************************************
 *
 *  uart.h - Definition file for UART communication using MSP430 TimerA 
 *         - peripheral  
 *
 *
 *
 ******************************************************************************/
 
//------------------------------------------------------------------------------
// Hardware-related definitions
//------------------------------------------------------------------------------
#define UART_TXD   0x02                     // TXD on P1.1 (Timer0_A.OUT0)
#define UART_RXD   0x04                     // RXD on P1.2 (Timer0_A.CCI1A)

//------------------------------------------------------------------------------
// Conditions for 9600 Baud SW UART, SMCLK = 1MHz
//------------------------------------------------------------------------------
#define UART_TBIT_DIV_2     (1000000 / (9600 * 2))
#define UART_TBIT           (1000000 / 9600)
#include "msp430g2452.h"
void TimerA_UART_init(void);
void TimerA_UART_shutdown(void);
void TimerA_UART_tx(unsigned char byte);
