/*******************************************************************************
 *
 *  GameGraphics.h
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *
 ******************************************************************************/

#ifndef GAME_GRAPHICS_H_
#define GAME_GRAPHICS_H_

#define MAX_IMAGE     7


//*****************************************************************************
//
// A bitmap for the space ship.
//
//*****************************************************************************
const uint8_t Game_ship[] = {
    0x3F, 0x1F, 0x1F, 0x0F, 0x0F, 0x07, 0x07, 0x03, 0x03, 0x01
};

//*****************************************************************************
//
// A bitmap for mine type one.
//
//*****************************************************************************
const uint8_t Game_mine1[] = {
    0x18, 0x3C, 0x7E, 0x7E, 0x3C, 0x18
};

//*****************************************************************************
//
// A bitmap for mine type two.
//
//*****************************************************************************
const uint8_t Game_mine2[] =
{
    0xC3, 0xC3, 0x3C, 0x3C, 0x3C, 0x3C, 0xC3, 0xC3
};

//*****************************************************************************
//
// A bitmap for the first stage of an explosion
//
//*****************************************************************************
const uint8_t Game_explosion1[] =
{
    0x28, 0x10, 0x28
};

//*****************************************************************************
//
// A bitmap for the second stage of an explosion
//
//*****************************************************************************
const uint8_t Game_explosion2[] =
{
    0x44, 0x28, 0x10, 0x28, 0x44
};

const uint8_t Game_explosion3[] =
{
    0x92, 0x54, 0x28, 0xD6, 0x28, 0x54, 0x92
};

const uint8_t Game_explosion4[] =
{
    0x10, 0x92, 0x54, 0x00, 0xD7, 0x00, 0x54, 0x92, 0x10,
};

//*****************************************************************************
//
// This array contains the sequence of explosion images, along with the width
// of each one.
//
//*****************************************************************************
const struct
{
    const uint8_t *image;
    unsigned int adjust;
    unsigned int width;
}

Game_explosion[4] =
{
    { Game_explosion1, 0, 3 },
    { Game_explosion2, 1, 5 },
    { Game_explosion3, 2, 7 },
    { Game_explosion4, 3, 9 }
};

#endif /*GAME_GRAPHICS_H_*/
