// *************************************************************************************************
//
//
// *************************************************************************************************

#ifndef ALTITUDE_H_
#define ALTITUDE_H_

// *************************************************************************************************
// Include section

// *************************************************************************************************
// Prototypes section
extern void reset_altitude_measurement(void);
extern void start_altitude_measurement(void);
extern void stop_altitude_measurement(void);
extern u8 is_altitude_measurement(void);
extern void do_altitude_measurement(u8 filter);

// menu functions
extern void display_altitude(u8 line, u8 update);

// *************************************************************************************************
// Defines section

// *************************************************************************************************
// Global Variable section
struct alt
{
    u8 on;                      // 1 = Measurement started, 0 = measurement off
    u32 pressure;               // Pressure (Pa)
    u16 temperature_K;          // Temperature in K
    s16 temperature_C;          // Temperature in C
    s16 temperature_C_offset;   // Temperature C offset
    s16 altitude;               // Altitude (m)
    s16 altitude_offset;        // Altitude offset stored during calibration
};
extern struct alt sAlt;

// *************************************************************************************************
// Extern section

#endif                          /*ALTITUDE_H_ */
