// *************************************************************************************************
//
//
// *************************************************************************************************

#ifndef BATTERY_H_
#define BATTERY_H_

// *************************************************************************************************
// Include section

// *************************************************************************************************
// Prototypes section

// Internal functions
extern void reset_batt_measurement(void);
extern void battery_measurement(void);

// *************************************************************************************************
// Defines section

// Battery high voltage threshold
#define BATTERY_HIGH_THRESHOLD                  (360u)

// Battery end of life voltage threshold -> disable radio, show "lobatt" message
#define BATTERY_LOW_THRESHOLD                   (240u)

// Show "lobatt" message every n seconds
#define BATTERY_LOW_MESSAGE_CYCLE               (15u)

// *************************************************************************************************
// Global Variable section
struct batt
{
    // Counter for alternating "lobatt" display
    u8 lobatt_display;

    // Battery voltage
    u16 voltage;

    // Battery voltage offset
    s16 offset;
};
extern struct batt sBatt;

// *************************************************************************************************
// Extern section

#endif                          /*BATTERY_H_ */
