// *************************************************************************************************
//
//
// *************************************************************************************************

#ifndef BLUEROBIN_H_
#define BLUEROBIN_H_

// *************************************************************************************************
// Include section
#include <project.h>

// *************************************************************************************************
// Prototypes section
extern void reset_bluerobin(void);
extern void mx_bluerobin(u8 line);
extern void sx_bluerobin(u8 line);
extern void display_heartrate(u8 line, u8 update);
extern u8 is_bluerobin(void);
extern u8 is_bluerobin_searching(void);
extern void get_bluerobin_data(void);
extern u8 start_bluerobin(void);
extern void stop_bluerobin(void);
extern u8 is_bluerobin_flash_write_window(void);

// *************************************************************************************************
// Defines section

// BlueRobin connection states
typedef enum
{
    BLUEROBIN_OFF = 0,          // Not connected
    BLUEROBIN_SEARCHING,        // Searching for transmitter
    BLUEROBIN_CONNECTED,        // Connected
    BLUEROBIN_ERROR             // Error occurred while trying to connect or while connected
} BlueRobin_state_t;

// BlueRobin data update states
typedef enum
{
    BLUEROBIN_NO_UPDATE = 0,    // No new data available
    BLUEROBIN_NEW_DATA          // New data arrived
} BlueRobin_update_t;

// *************************************************************************************************
// Global Variable section
struct bluerobin
{
    BlueRobin_state_t state;    // BLUEROBIN_OFF, BLUEROBIN_SEARCHING, BLUEROBIN_CONNECTED,
                                // BLUEROBIN_ERROR
    BlueRobin_update_t update;  // BLUEROBIN_NO_UPDATE, BLUEROBIN_NEW_DATA
    u32 cs_id;                  // BLUEROBIN_NO_UPDATE, BLUEROBIN_NEW_DATA
    u8 heartrate;               // Heart rate (1 bpm)
};
extern struct bluerobin sBlueRobin;

// *************************************************************************************************
// Extern section

#endif                          /*BLUEROBIN_H_ */
