// *************************************************************************************************
//
//
// *************************************************************************************************

#ifndef ACCELERATION_H_
#define ACCELERATION_H_

// *************************************************************************************************
// Include section

// *************************************************************************************************
// Prototypes section

// *************************************************************************************************
// Defines section
#define DISPLAY_ACCEL_X         (0u)
#define DISPLAY_ACCEL_Y         (1u)
#define DISPLAY_ACCEL_Z         (2u)

#define ACCEL_MODE_OFF          (0u)
#define ACCEL_MODE_ON           (1u)

// Stop acceleration measurement after 60 minutes to save battery
#define ACCEL_MEASUREMENT_TIMEOUT               (60 * 60u)

// *************************************************************************************************
// Global Variable section
struct accel
{
    u8 mode;                    // ACC_MODE_OFF, ACC_MODE_ON
    u8 xyz[3];                  // Sensor raw data
    u16 data;                   // Acceleration data in 10 * mgrav
    u8 view_style;              // Display X/Y/Z values
    u16 timeout;                // Timeout
};
extern struct accel sAccel;

// *************************************************************************************************
// Extern section
extern void reset_acceleration(void);
extern void sx_acceleration(u8 line);
extern void display_acceleration(u8 line, u8 update);
extern u8 is_acceleration_measurement(void);
extern void do_acceleration_measurement(void);

#endif                          /*ACCELERATION_H_ */
