// *************************************************************************************************
//
//
// *************************************************************************************************

#ifndef ALTITUDE_H_
#define ALTITUDE_H_

// *************************************************************************************************
// Include section

// *************************************************************************************************
// Prototypes section
extern void reset_altitude_measurement(void);
extern u8 is_altitude_measurement(void);
extern void start_altitude_measurement(void);
extern void stop_altitude_measurement(void);
extern void do_altitude_measurement(u8 filter);

// menu functions
extern void sx_altitude(u8 line);
extern void mx_altitude(u8 line);
extern void display_altitude(u8 line, u8 update);

// *************************************************************************************************
// Defines section
#define ALTITUDE_MEASUREMENT_TIMEOUT    (60 * 60u) // Stop altitude measurement after 60 minutes to
                                                   // save battery

// *************************************************************************************************
// Global Variable section
struct alt
{
    menu_t state;                                  // MENU_ITEM_NOT_VISIBLE, MENU_ITEM_VISIBLE
    u32 pressure;                                  // Pressure (Pa)
    u16 temperature;                               // Temperature (K)
    s16 altitude;                                  // Altitude (m)
    s16 altitude_offset;                           // Altitude offset stored during calibration
    u16 timeout;                                   // Timeout
};
extern struct alt sAlt;

// *************************************************************************************************
// Extern section

#endif                                             /*ALTITUDE_H_ */
