// *************************************************************************************************
//
//
// *************************************************************************************************

#ifndef STOPWATCH_H_
#define STOPWATCH_H_

// *************************************************************************************************
// Include section
#include <project.h>

// *************************************************************************************************
// Prototypes section
extern void start_stopwatch(void);
extern void stop_stopwatch(void);
extern void reset_stopwatch(void);
extern u8 is_stopwatch(void);
extern void stopwatch_tick(void);
extern void update_stopwatch_timer(void);
extern void mx_stopwatch(u8 line);
extern void sx_stopwatch(u8 line);
extern void display_stopwatch(u8 line, u8 update);

// *************************************************************************************************
// Defines section
#define STOPWATCH_1HZ_TICK                      (32768 / 1)
#define STOPWATCH_100HZ_TICK            (32768 / 100)
#define STOPWATCH_STOP                          (0u)
#define STOPWATCH_RUN                           (1u)
#define STOPWATCH_HIDE                          (2u)

// *************************************************************************************************
// Global Variable section
struct stopwatch
{
    u8 state;
    u8 drawFlag;
    u8 swtIs1Hz;
    u8 swtIs10Hz;

    u8 time[8];                 // time[0]      hour H
    // time[1]      hour L
    // time[2]      minute H
    // time[3]      minute L
    // time[4]      second H
    // time[5]      second L
    // time[6]      1/10 sec
    // time[7]      1/100 sec

    // Display style
    u8 viewStyle;
};
extern struct stopwatch sStopwatch;

// *************************************************************************************************
// Extern section

#endif                          /*STOPWATCH_H_ */
