//******************************************************************************
//   MSP430F673x Demo - MPY32, 32x32 Signed Multiply
//
//   Description: Hardware multiplier is used to multiply two numbers.
//   The calculation is automatically initiated after the second operand is
//   loaded. Results are stored in RES0, RES1, RES2 and RES3.
//
//   ACLK = 32.768kHz, MCLK = SMCLK = default DCO
//
//                MSP430F673X
//             -----------------
//         /|\|                 |
//          | |                 |
//          --|RST              |
//            |                 |
//            |                 |
//
//   M. Swanson
//   Texas Instruments Inc.
//   December 2011
//   Built with CCS Version: 5.1.0 and IAR Embedded Workbench Version: 5.40.1
//******************************************************************************
#include <msp430.h>

int main(void)
{
    WDTCTL = WDTPW | WDTHOLD;               // Stop WDT

    MPYS32L = 0x1234;                       // Load lower 16 bits of operand 1
    MPYS32H = 0x1234;                       // Load upper 16 bits of operand 1

    OP2L = 0xE9D2;                          // Load lower 16 bits of operand 2
    OP2H = 0xE9D2;                          // Load upper 16 bits of operand 2
    __no_operation();                       // Wait for result to become ready
    __no_operation();
    __no_operation();
    __no_operation();
    __no_operation();

    __bis_SR_register(LPM4_bits);           // Enter LPM4
    __no_operation();                       // For debugger
}

