//******************************************************************************
//  MSP430F673x Demo - Write a byte to Port 1
//
//  Description: Writes a byte(0xFF) to Port 1 and stays in LPM4 mode
//
//  ACLK = n/a, MCLK = SMCLK = default DCO
//
//               MSP430F673x
//            -----------------
//        /|\|                 |
//         | |                 |
//         --|RST              |
//           |             P1.x|-->HI
//           |                 |
//           |                 |
//
//  M. Swanson
//  Texas Instruments Inc.
//  December 2011
//  Built with CCS Version: 5.1.0 and IAR Embedded Workbench Version: 5.40.1
//******************************************************************************
#include <msp430.h>

int main(void)
{
    WDTCTL = WDTPW | WDTHOLD;               // Stop WDT

    // Setup P1.x output
    P1DIR |= 0xFF;                          // Set P1.x to output direction
    P1OUT |= 0xFF;                          // Set P1.x

    __bis_SR_register(LPM4_bits | GIE);     // Enter LPM4 w/interrupt
    __no_operation();                       // For debugger
}

