//******************************************************************************
//  MSP430F673x Demo - Write a word to Port A (Port1+Port2)
//
//  Description: Writes a word(FFFFh) to Port A and stays in LPM4
//
//  ACLK = n/a, MCLK = SMCLK = default DCO
//
//               MSP430F673x
//            -----------------
//        /|\|                 |
//         | |                 |
//         --|RST           PA.x|-->HI
//           |                 |
//           |                 |
//
//  M. Swanson
//  Texas Instruments Inc.
//  December 2011
//  Built with CCS Version: 5.1.0 and IAR Embedded Workbench Version: 5.40.1
//******************************************************************************
#include <msp430.h>

int main(void)
{
    WDTCTL = WDTPW | WDTHOLD;               // Stop WDT

    // Setup P1.x output
    PADIR |= 0xFF;                          // Set PA.x to output direction
    PAOUT |= 0xFF;                          // Set PA.x

    __bis_SR_register(LPM4_bits | GIE);     // Enter LPM4 w/ interrupts
    __no_operation();                       // For debugger
}

