//******************************************************************************
//   MSP430FR59xx Demo - Configure MCLK for 8MHz operation
//
//   Description: Configure SMCLK = MCLK = 8MHz
//
//           MSP430FR59x
//         ---------------
//     /|\|               |
//      | |               |
//      --|RST            |
//        |               |
//        |               |
//        |          P3.4 |---> SMCLK = MCLK = 8MHz
//
//   T. Witt/ P. Thanigai
//   Texas Instruments Inc.
//   November 2011
//   Built with IAR Embedded Workbench V5.30 & Code Composer Studio V5.1
//******************************************************************************

#include <msp430.h>

int main(void)
{
  WDTCTL = WDTPW | WDTHOLD;                 // Stop WDT

  CSCTL0_H = 0xA5;
  CSCTL1 = DCOFSEL_6;                       // Set max. DCO setting
  CSCTL2 = SELS_3 + SELM_3;                 // set SMCLK = MCLK = DCO
  CSCTL3 = DIVS_0 + DIVM_0;                 // set all dividers
  CSCTL0_H = 0;                             // Lock CS registers
    
  P3OUT = 0;                                // output SMCLK
  P3DIR |= BIT4;
  P3SEL1 |= BIT4;

  while(1);

}
