//******************************************************************************
//   MSP430FR59xx Demo - Enters LPM4
//
//   Description: Device enters LPM4
//
//          MSP430FR5969
//         ---------------
//     /|\|               |
//      | |               |
//      --|RST            |
//        |               |
//        |               |
//        |          P1.0 |---> Disconnect JP9 for power meas.
//
//   T. Witt/ P. Thanigai
//   Texas Instruments Inc.
//   December 2011
//   Built with IAR Embedded Workbench V5.30 & Code Composer Studio V5.1
//******************************************************************************

#include <msp430.h>

int main(void)
{
  WDTCTL = WDTPW | WDTHOLD;                 // Stop WDT

  P1DIR = 0;
  P1OUT = 0;
  P1REN = 0xFF;

  P2DIR = 0;
  P2OUT = 0;
  P2REN = 0xFF;

  P3DIR = 0;
  P3OUT = 0;
  P3REN = 0xFF;

  P4DIR = 0;
  P4OUT = 0;
  P4REN = 0xFF;

  PJDIR = 0xFFFF;
  PJOUT = 0;

  CSCTL0_H = 0xA5;
  CSCTL1  = DCOFSEL_6;                      // Set max. DCO setting
  CSCTL2 = SELM__DCOCLK + SELS__DCOCLK + SELA__VLOCLK; // set ACLK = VLO; MCLK = DCO
  CSCTL3 = DIVA__1 | DIVS__1 | DIVM__1;     // set all dividers

  CSCTL4 = LFXTOFF | HFXTOFF;
  CSCTL5 &= ~(LFXTOFFG | HFXTOFFG);

  __bis_SR_register(LPM4_bits);
  __no_operation();                         // For debugger
}
