//******************************************************************************
//!  AES Encryption and Decryption Example
//!
//!  Description: This demo shows how to use the AES Encryption and Decryption
//!
//!               CC430F5137
//!             -----------------

//!
//! This example uses the following peripherals and I/O signals.  You must
//! review these and change as needed for your own board:
//! - WDT peripheral
//! - AES
//!
//! This example uses the following interrupt handlers.  To use this example
//! in your own application you must add these interrupt handlers to your
//! vector table.
//! - None.
//******************************************************************************
#include "inc/hw_memmap.h"
#include "driverlib/5xx_6xx/wdt.h"
#include "driverlib/5xx_6xx/aes.h"


void main(void){
	unsigned char Data[16] = 		{	0x30, 0x30, 0x30, 0x30,
	 									0x30, 0x30, 0x30, 0x30,
										0x30, 0x30, 0x30, 0x30,
										0x30, 0x30, 0x30, 0x30	};
	unsigned char CipherKey[16] = 	{	0x30, 0x30, 0x30, 0x30,
										0x30, 0x30, 0x30, 0x30,
										0x30, 0x30, 0x30, 0x30,
										0x30, 0x30, 0x30, 0x30	};
	unsigned char DataAESencrypted[16];		// Encrypted data
	unsigned char DataAESdecrypted[16];	// Decrypted data
	
	// stop watchdog
	WDT_hold(__MSP430_BASEADDRESS_WDT_A__);

	
	// Load a cipher key to module
	//AES_setCipherKey(__MSP430_BASEADDRESS_AES__, CipherKey);
	AES_setCipherKey(__MSP430_BASEADDRESS_AES__, CipherKey );
	
	// Encrypt data with preloaded cipher key
	AES_encryptData(__MSP430_BASEADDRESS_AES__, Data, DataAESencrypted);
	
	// Reset module (not mandatory - just to delete all registers and keys)
	AES_reset(__MSP430_BASEADDRESS_AES__);
	
	// Load and generate decryption key for 1st decryption round - takes ~52 MCLK
	AES_generateFirstRoundKey(__MSP430_BASEADDRESS_AES__, CipherKey);
	
	// Decrypt data by using pregenerated key - takes ~167 MCLK
	AES_decryptData(__MSP430_BASEADDRESS_AES__, DataAESencrypted, DataAESdecrypted);
	
	// Array DataunAES should now contain the same data as array Data

    while(1){};
}
