//******************************************************************************
//!  AES256 Encryption and Decryption Example
//!
//!  Description: This demo shows how to use the AES Encryption and Decryption
//!
//!               MSP430FR5969
//!             -----------------

//!
//! This example uses the following peripherals and I/O signals.  You must
//! review these and change as needed for your own board:
//! - WDT peripheral
//! - AES256
//!
//! This example uses the following interrupt handlers.  To use this example
//! in your own application you must add these interrupt handlers to your
//! vector table.
//! - None.
//******************************************************************************
//#include "inc/hw_memmap.h"
#include "msp430fr5969.h"
#include "driverlib/5xx_6xx/wdt.h"
#include "driverlib/5xx_6xx/aes256.h"

unsigned char Data[16] = 		{	0x30, 0x30, 0x30, 0x30,
	 								0x30, 0x30, 0x30, 0x30,
	 								0x30, 0x30, 0x30, 0x30,
	 								0x30, 0x30, 0x30, 0x30	};

unsigned char CipherKey[32] = 	{	0xAA, 0xBB, 0x02, 0x03,
									0x04, 0x05, 0x06, 0x07,
									0x08, 0x09, 0x0A, 0x0B,
									0x0C, 0x0D, 0x0E, 0x0F,
									0x30, 0x31, 0x32, 0x33,
									0x34, 0x35, 0x36, 0x37,
									0x30, 0x31, 0x32, 0x33,
									0x34, 0x35, 0x36, 0x37	};
unsigned char DataAESencrypted[16];		// Encrypted data
unsigned char DataAESdecrypted[16];		// Decrypted data
int i = 0;

void main(void){
	// stop watchdog
	WDT_hold(__MSP430_BASEADDRESS_WDT_A__);

	// Load a cipher key to module
	AES256_setCipherKey(__MSP430_BASEADDRESS_AES256__, CipherKey, Key_256BIT);

	// Encrypt data with preloaded cipher key
	AES256_encryptData(__MSP430_BASEADDRESS_AES256__, Data, DataAESencrypted);
	
	// Decrypt data with keys that were generated during encryption - takes 214 MCLK
	// This function will generate all round keys needed for decryption first and then
	// the encryption process starts
	AES256_decryptDataUsingEncryptionKey(__MSP430_BASEADDRESS_AES256__, DataAESencrypted, DataAESdecrypted);

	// Array DataunAES should now contain the same data as array Data

    while(1){};
}

