//#include "inc/hw_memmap.h"
#include "msp430fr5969.h"
#include "driverlib/5xx_6xx/cs_a.h"
#include "driverlib/5xx_6xx/wdt.h"
#include "driverlib/5xx_6xx/frgpio.h"

//******************************************************************************
//   MSP430FR59xx Demo - Configure MCLK for 8MHz operation
//
//   Description: Configure SMCLK = MCLK = 8MHz
//
//           MSP430FR59x
//         ---------------
//     /|\|               |
//      | |               |
//      --|RST            |
//        |               |
//        |               |
//        |          P3.4 |---> SMCLK = MCLK = 8MHz
//******************************************************************************

void main(void)
{

  //Stop WDT
  WDT_hold(__MSP430_BASEADDRESS_WDT_A__);


  //Set DCO Frequency to 8MHz
  CSA_setDCOFreq(__MSP430_BASEADDRESS_CS_A__,CSA_DCORSEL_0,CSA_DCOFSEL_6);

  //configure MCLK, SMCLK to be source by DCOCLK
  CSA_clockSignalInit(__MSP430_BASEADDRESS_CS_A__,CSA_SMCLK,CSA_DCOCLK_SELECT,CSA_CLOCK_DIVIDER_1);
  CSA_clockSignalInit(__MSP430_BASEADDRESS_CS_A__,CSA_MCLK,CSA_DCOCLK_SELECT,CSA_CLOCK_DIVIDER_1);

  // output SMCLK
  FRGPIO_setOutputLowOnPin(__MSP430_BASEADDRESS_PORT3_R__,
			FRGPIO_PORT_P3,
			FRGPIO_PIN4
	);

  FRGPIO_setAsPeripheralModuleFunctionOutputPin(__MSP430_BASEADDRESS_PORT3_R__,
			FRGPIO_PORT_P3,
			FRGPIO_PIN4,
			FRGPIO_TERNARY_MODULE_FUNCTION
	);

  while(1);
}

