//******************************************************************************
//   MSP430FR59xx Demo - Configure MCLK for 8MHz operation
//
//   Description: Configure SMCLK = MCLK = 8MHz
//
//           MSP430FR59x
//         ---------------
//     /|\|               |
//      | |               |
//      --|RST            |
//        |               |
//        |               |
//        |          P3.4 |---> SMCLK = MCLK = 8MHz
//******************************************************************************

#include "inc/hw_memmap.h"
#include "cs.h"
#include "wdt_a.h"
#include "gpio.h"

void main(void)
{

  //Stop WDT
  WDT_A_hold(WDT_A_BASE);


  //Set DCO Frequency to 8MHz
  CS_setDCOFreq(CS_BASE,CS_DCORSEL_0,CS_DCOFSEL_6);

  //configure MCLK, SMCLK to be source by DCOCLK
  CS_clockSignalInit(CS_BASE,CS_SMCLK,CS_DCOCLK_SELECT,CS_CLOCK_DIVIDER_1);
  CS_clockSignalInit(CS_BASE,CS_MCLK,CS_DCOCLK_SELECT,CS_CLOCK_DIVIDER_1);

  // output SMCLK
  GPIO_setOutputLowOnPin(
			GPIO_PORT_P3,
			GPIO_PIN4
	);

  GPIO_setAsPeripheralModuleFunctionOutputPin(
			GPIO_PORT_P3,
			GPIO_PIN4,
			GPIO_TERNARY_MODULE_FUNCTION
	);

  while(1);
}

