#include "inc\hw_memmap.h"
#include "grlib.h"
#include "Hitachi138x110_HD66753.h"
#include "images.h"
#include "driverlibHeaders.h"


tContext g_sContext;
tRectangle g_sRect;
long stringWidth = 0;

void halBoardInit(void);
void clockInit();

tRectangle myRectangle1 = { 5, 40, 15, 50};
tRectangle myRectangle2 = { 20, 40, 30, 50};
/**********************************************************************//**
 * @brief  This is the example code's main function.
 *
 * @param  none
 *
 * @return none
 *************************************************************************/

void main (void)
{

    halBoardInit();
	
    clockInit();

    // Initialize LCD and backlight
    Hitachi138x110_HD66753Init();
    Hitachi138x110_InvertDisplay();
    
    // Initialize grlib parameters
    GrContextInit(&g_sContext, &g_sHitachi138x110_HD66753);
    GrContextFontSet(&g_sContext, &g_sFontCmss12b);
    
    GrContextForegroundSet(&g_sContext, ClrBlack);
    GrContextBackgroundSet(&g_sContext, ClrWhite);
    
    // Clear Screen
    GrClearDisplay(&g_sContext);
    
    GrCircleDraw(&g_sContext, 10, 30, 5);
    GrCircleFill(&g_sContext, 25, 30, 5);

    GrRectDraw(&g_sContext, &myRectangle1 );
    GrRectFill(&g_sContext, &myRectangle2);


    GrPixelDraw(&g_sContext, 50, 50);
    
    GrStringDraw(&g_sContext, "Welcome to ", -1, 2, 3, 0);
    GrLineDraw(&g_sContext, 3,15, 70,15);
    stringWidth = GrStringWidthGet(&g_sContext, "Welcome to", -1);

    GrContextForegroundSet(&g_sContext, ClrWhite );
    GrContextBackgroundSet(&g_sContext, ClrBlack);
    GrStringDraw(&g_sContext, "Dallas TX", -1, 5, 70, 1);

    __no_operation();
      
    GrContextForegroundSet(&g_sContext, ClrWhite);
    GrContextBackgroundSet(&g_sContext, ClrBlack);
    GrLineDraw(&g_sContext, 3,15, 70,15);

    __no_operation();
      
    GrClearDisplay(&g_sContext);
    // Draw TI Logo
    GrImageDraw(&g_sContext, &Pig1BPP_UNCOMP, 1, 10);
   
    while(1)
	{
	}

}
 	
void halBoardInit(void)
{
    //Tie unused ports
    GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORTA_R__,
        GPIO_PORT_PA,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORTA_R__,
        GPIO_PORT_PA,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORTB_R__,
        GPIO_PORT_PB,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORTB_R__,
        GPIO_PORT_PB,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORTC_R__,
        GPIO_PORT_PC,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORTC_R__,
        GPIO_PORT_PC,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
  
    GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORTD_R__,
        GPIO_PORT_PD,
        GPIO_PIN2 + GPIO_PIN3 + GPIO_PIN4 + GPIO_PIN5 + 
        GPIO_PIN6 + GPIO_PIN7 + GPIO_PIN8 + GPIO_PIN9 + 
        GPIO_PIN10 + GPIO_PIN11 + GPIO_PIN12 + GPIO_PIN13 + 
        GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setAsPeripheralModuleFunctionOutputPin(
        __MSP430_BASEADDRESS_PORTD_R__,
        GPIO_PORT_PD,
        GPIO_PIN0 + GPIO_PIN1
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORTD_R__,
        GPIO_PORT_PD,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    

   // P10.0 to USB RST pin,
   // ...if enabled with J5
   GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORT11_R__,
        GPIO_PORT_P11,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 +
        GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + GPIO_PIN12 + 
        GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setAsInputPin(
        __MSP430_BASEADDRESS_PORTE_R__,
        GPIO_PORT_PE,
        GPIO_PIN8
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORTE_R__,
        GPIO_PORT_PE,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORT11_R__,
        GPIO_PORT_P11,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORT11_R__,
        GPIO_PORT_P11,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7
        );
    
    GPIO_setAsOutputPin(
        __MSP430_BASEADDRESS_PORTJ_R__,
        GPIO_PORT_PJ,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7  +
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );
    
    GPIO_setOutputLowOnPin(
        __MSP430_BASEADDRESS_PORTJ_R__,
        GPIO_PORT_PJ,
        GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN6 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
        );


   
    GPIO_setOutputLowOnPin(
       __MSP430_BASEADDRESS_PORT6_R__,
       GPIO_PORT_P6,
       GPIO_PIN0 + GPIO_PIN1 + GPIO_PIN2 + GPIO_PIN3 + 
        GPIO_PIN4 + GPIO_PIN5 + GPIO_PIN7 + 
        GPIO_PIN8 + GPIO_PIN9 + GPIO_PIN10 + GPIO_PIN11 + 
        GPIO_PIN12 + GPIO_PIN13 + GPIO_PIN14 + GPIO_PIN15 
         );
    
    GPIO_setOutputHighOnPin(
       __MSP430_BASEADDRESS_PORT6_R__,
       GPIO_PORT_P6,
       GPIO_PIN6
       );
    
    // USB RX Pin, Input with
    // ...pulled down Resistor
    
    GPIO_setAsInputPinWithPullDownresistor(
        __MSP430_BASEADDRESS_PORT5_R__,
        GPIO_PORT_P5,
        GPIO_PIN7
        );
    
     GPIO_setOutputLowOnPin(
       __MSP430_BASEADDRESS_PORT5_R__,
       GPIO_PORT_P5,
       GPIO_PIN7
         );
       
                            
}
void clockInit()
{
	UCS_setExternalClockSource(__MSP430_BASEADDRESS_UCS__,
                               32768,
                               0);
    
    UCS_LFXT1Start(
        __MSP430_BASEADDRESS_UCS__,
        UCS_XT1_DRIVE0,
        UCS_XCAP_3       
        );
    
     UCS_initFLLSettle(
                  __MSP430_BASEADDRESS_UCS__,
                  16000,
                  488
                  );
    
    
    SFR_enableInterrupt(__MSP430_BASEADDRESS_SFR__,
                        SFR_OSCILLATOR_FAULT_INTERRUPT
                       );

}
