//******************************************************************************
//RO_COMPB_TA1_WDTA example
//                                                         MSP430F5529
//                                                        +---------------+
//                                                        | 
//c-+--------------------------------------------------R--+--<P1.6/TA1CLK/CBOUT  
//  |                                                     |
//  |  c-+---------------------------------------------R--+  
//  |    |                                                |
//  |    |  c-+----------------------------------------R--+  
//  |    |    |                                           |
//  |    |    | c-+------------------------------------R--+  
//  |    |    |   |                                       |
//                  c-+--------------------------------R--+  
//                    |                                   |
//                    |  c-+---------------------------R--+  
//                    |    |                              |
//                    |    |  c-+----------------------R--+  
//                    |    |    |                         |
//                    |    |    | c-+------------------R--+  
//                    |    |    |   |                     |
//                    |    |    |   |  c-+-------------R--+  
//                    |    |    |   |    |                |
//                    |    |    |   |    | c-+---------R--+  
//                    |    |    |   |    |   |            |
//                    |    |    |   |    |   | c-+-----R--+  
//                    |    |    |   |    |   |   |        |
//                    |    |    |   |    |   |   | c-+-R--+                               
//                    |    |    |   |    |   |   |   |
//                    |    |    |   |    |   |   |   +------->CB0
//                    |    |    |   |    |   |   +----------->CB1
//                    |    |    |   |    |   +--------------->CB2
//                    |    |    |   |    +------------------->CB3
//                    |    |    |   +------------------------>CB4
//                    |    |    +---------------------------->CB5
//                    |    +--------------------------------->CB6
//  |    |    |   |   +-------------------------------------->CB7
//  |    |    |   +------------------------------------------>CB8
//  |    |    +---------------------------------------------->CB9
//  |    +--------------------------------------------------->CB10
//  +-------------------------------------------------------->CB11
//
//******************************************************************************
#include "CTS_Layer.h"

#define NUM_SEN	12

uint16_t dCnt[NUM_SEN];
struct Element* keypressed;

const struct Element* address_list[NUM_SEN] = 
{
	&element0,
	&element1,
	&element2,
	&element3,
	&element4,
	&element5,
	&element6,
	&element7,
	&element8,
	&element9,
	&elementA,
	&elementB
};						

// Main Function
void main(void)
{ 
  uint8_t i;
  WDTCTL = WDTPW + WDTHOLD;             // Stop watchdog timer

  // establish baseline
  TI_CAPT_Init_Baseline(&keypad);
  TI_CAPT_Update_Baseline(&keypad,5);

  // Main loop starts here
  while (1)
  {
      keypressed = (struct Element *)TI_CAPT_Buttons(&keypad);
      TI_CAPT_Custom(&keypad,dCnt);
      if(keypressed)
      {
          for(i=0; i<NUM_SEN; i++)
          {
      	      if (keypressed == address_list[i])
	      {
	          //dCnt[i];
                   __no_operation();
              }
           }  
      }
  }
} // End Main

