//******************************************************************************
//
//                         MSP430G2452
//                      +---------------+
//                      |
//             C--------|P1.0
//             C--------|P1.1
//             C--------|P1.2
//             C--------|P1.3
//             C--------|P1.4
//             C--------|P1.5
//                      |
//           C----------|P2.0
//           C----------|P2.1
//           C----------|P2.2
//           C----------|P2.3
//           C----------|P2.4
//           C----------|P2.5
//                      |
//           C----------|P2.6
//           C----------|P2.7
//
//******************************************************************************

#include "structure.h"

//PinOsc P1.0
const struct Element element0 = {

              .inputPxselRegister = (uint8_t *)&P1SEL,  
              .inputPxsel2Register = (uint8_t *)&P1SEL2,  
              .inputBits = BIT0,
              .maxResponse = 121+655, 
              .threshold = 121 

};     

const struct Element element1 = {

              .inputPxselRegister = (uint8_t *)&P1SEL,  
              .inputPxsel2Register = (uint8_t *)&P1SEL2,  
              .inputBits = BIT1,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
    
const struct Element element2 = {

              .inputPxselRegister = (uint8_t *)&P1SEL,  
              .inputPxsel2Register = (uint8_t *)&P1SEL2,  
              .inputBits = BIT2,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
    
const struct Element element3 = {

              .inputPxselRegister = (uint8_t *)&P1SEL,  
              .inputPxsel2Register = (uint8_t *)&P1SEL2,  
              .inputBits = BIT3,
              .maxResponse = 121+655, 
              .threshold = 121 

};      

const struct Element element4 = {

              .inputPxselRegister = (uint8_t *)&P1SEL,  
              .inputPxsel2Register = (uint8_t *)&P1SEL2,  
              .inputBits = BIT4,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
    
const struct Element element5 = {

              .inputPxselRegister = (uint8_t *)&P1SEL,  
              .inputPxsel2Register = (uint8_t *)&P1SEL2,  
              .inputBits = BIT5,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
//PinOsc P2.0
const struct Element element6 = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT0,
              .maxResponse = 121+655, 
              .threshold = 121 

};     
const struct Element element7 = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT1,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
const struct Element element8 = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT2,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
const struct Element element9 = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT3,
              .maxResponse = 121+655, 
              .threshold = 121 

};      
const struct Element elementA = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT4,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
const struct Element elementB = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT5,
              .maxResponse = 121+655, 
              .threshold = 121 

};  
const struct Element elementC = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT6,
              .maxResponse = 121+655, 
              .threshold = 121 

};      
const struct Element elementD = {

              .inputPxselRegister = (uint8_t *)&P2SEL,  
              .inputPxsel2Register = (uint8_t *)&P2SEL2,  
              .inputBits = BIT7,
              .maxResponse = 121+655, 
              .threshold = 121 

};      


//*** Sensor     *******************************************************/
// This defines the grouping of sensors, the method to measure change in
// capacitance, and the function of the group

const struct Sensor keypad =
               { 
                  .halDefinition = fRO_PINOSC_TA0_SW,
                  .numElements = 14,
                  .baseOffset = 0,
                  // Pointer to elements
                  .arrayPtr[0] = &element0,  // point to first element
				  .arrayPtr[1] = &element1,  // point to first element
                  .arrayPtr[2] = &element2,  // point to first element
                  .arrayPtr[3] = &element3,  // point to first element
                  .arrayPtr[4] = &element4,  // point to first element
                  .arrayPtr[5] = &element5,  // point to first element
                  .arrayPtr[6] = &element6,  // point to first element
                  .arrayPtr[7] = &element7,  // point to first element
                  .arrayPtr[8] = &element8,  // point to first element
                  .arrayPtr[9] = &element9,  // point to first element
                  .arrayPtr[10] = &elementA,  // point to first element
                  .arrayPtr[11] = &elementB,  // point to first element
                  .arrayPtr[12] = &elementC,  // point to first element
				  .arrayPtr[13] = &elementD,  // point to first element

                  // Timer Information
                  .accumulationCycles= 100             //number of ACLK cycles              
               };
