/* 
 * ======== UsbIsr.h ========
 */
#ifndef _ISR_H_
#define _ISR_H_

#ifdef __cplusplus
extern "C"
{
#endif

/**
 * Handle incoming setup packet.
 * returns TRUE to keep CPU awake
 */
BYTE SetupPacketInterruptHandler(VOID);

/**
 * Handle VBuss on signal.
 */
VOID PWRVBUSonHandler(VOID);

/**
 * Handle VBuss off signal.
 */
VOID PWRVBUSoffHandler(VOID);

/**
 * Handle In-requests from control pipe.
 */
VOID IEP0InterruptHandler(VOID);

/**
 * Handle Out-requests from control pipe.
 */
BYTE OEP0InterruptHandler(VOID);

/*----------------------------------------------------------------------------+
 | End of header file                                                          |
 +----------------------------------------------------------------------------*/

#ifdef __cplusplus
}
#endif
#endif  /* _ISR_H_ */

/*------------------------ Nothing Below This Line --------------------------*/
